#!/usr/bin/env python2

"""
Convert raw RGB888 images exported by The GIMP to RGB565 images.

Copyright (C) 2023 Paul Boddie <paul@boddie.org.uk>

This program is free software; you can redistribute it and/or modify it under
the terms of the GNU General Public License as published by the Free Software
Foundation; either version 3 of the License, or (at your option) any later
version.

This program is distributed in the hope that it will be useful, but WITHOUT ANY
WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A
PARTICULAR PURPOSE.  See the GNU General Public License for more details.

You should have received a copy of the GNU General Public License along
with this program.  If not, see <http://www.gnu.org/licenses/>.
"""

import sys

# Permit big endian for 8-byte transfers.

big_endian = "--big-endian" in sys.argv[3:]

f = open(sys.argv[1])
s = f.read()
f.close()

f = open(sys.argv[2], "w")

for i in xrange(0, len(s), 3):
    r, g, b = map(ord, s[i:i+3])
    rgb16 = ((r >> 3) << 11) | ((g >> 2) << 5) | (b >> 3)
    msb = chr(rgb16 >> 8)
    lsb = chr(rgb16 & 0xff)

    if big_endian:
        f.write(msb + lsb)
    else:
        f.write(lsb + msb)

f.close()

# vim: tabstop=4 expandtab shiftwidth=4
